<?php

namespace Drupal\drd;

use Drupal\drd\Entity\CoreInterface;
use Drupal\drd\Entity\DomainInterface;
use Drupal\drd\Entity\HostInterface;

/**
 * Interface for DRD entities queries service.
 */
interface EntitiesInterface {

  /**
   * @param int $id
   *
   * @return EntitiesInterface
   */
  public function setHostId($id);

  /**
   * @param int $id
   *
   * @return EntitiesInterface
   */
  public function setCoreId($id);

  /**
   * @param int $id
   *
   * @return EntitiesInterface
   */
  public function setDomainId($id);

  /**
   * @return HostInterface[]
   */
  public function hosts();

  /**
   * @return CoreInterface[]
   */
  public function cores();

  /**
   * @return DomainInterface[]
   */
  public function domains();

}
