<?php

namespace Drupal\drd\Plugin\Action;

use Drupal\drd\Entity\Core;
use Drupal\drd\Entity\CoreInterface;
use Drupal\drd\Entity\DomainInterface;

/**
 * Provides a 'DomainMove' action.
 *
 * @Action(
 *  id = "drd_action_domainmove",
 *  label = @Translation("Move domain to a different core"),
 *  type = "drd_domain",
 * )
 */
class DomainMove extends BaseEntity {

  /** @var CoreInterface */
  protected $core;

  /**
   * @inheritdoc
   */
  public function executeAction($domain) {
    /** @var DomainInterface $domain */

    if (!isset($this->core)) {
      $this->core = Core::load($this->arguments['dest-core-id']);
    }

    if (!$this->core) {
      $this->setOutput('Give core id is not valid.');
      return FALSE;
    }

    $domain
      ->setCore($this->core)
      ->save();

    $this->setOutput('Domain moved to core ' . $this->core->getName());
    return TRUE;
  }

}
